package de.fitko.fitconnect;

import de.fitko.fitconnect.api.domain.model.submission.CreatedSubmission;
import de.fitko.fitconnect.client.*;

import java.util.Collections;
import java.util.List;
import java.util.UUID;

public class TestRunner {

    public static void main(String[] args) {
        senderSample();
    }

    private static void senderSample() {

        // No DI
        ClientFactory.senderClient().send(UUID.randomUUID(), Collections.emptyList());

        // With Guice DI straight call in one go
        FluentSenderClient.build().send(UUID.randomUUID(), Collections.emptyList());
        FluentSenderClient.build().send(UUID.randomUUID(), Collections.emptyList(), "some json or xml");

        // Without data
        FluentSenderClient.build()
                .withDestination(UUID.randomUUID())
                .withAttachments(Collections.emptyList())
                .submit();

        // With data
        FluentSenderClient.build()
                .withDestination(UUID.randomUUID())
                .withAttachments(Collections.emptyList())
                .withData("some json or xml")
                .submit();
    }

    private static void subscriberSample() {

        var client = ClientFactory.subscriberClient();

        List<CreatedSubmission> submissions = client.getAvailableSubmissions(UUID.randomUUID(), 0, 100);

        // filter submissions for requested one
        CreatedSubmission submission = client.requestSubmission(UUID.fromString("123"));

    }

}
